
#include <stdio.h>
#include "eif_eiffel.h"
#include "eif_portable.h"
#include "eif_macros.h"

float eif_real_32_negative_infinity;
double eif_real_64_negative_infinity;
float eif_real_32_positive_infinity;
double eif_real_64_positive_infinity;
float eif_real_32_nan;
double eif_real_64_nan;


void ieee_init (void) {
  union {
    EIF_NATURAL_32 nat_val_32;
    EIF_REAL_32 real_val_32; } val_32;
  union {
    EIF_NATURAL_64 nat_val_64;
    EIF_REAL_64 real_val_64; } val_64;

		/* Computation of NaN. */
	val_32.nat_val_32 = 0x7FC00000;
	eif_real_32_nan = val_32.real_val_32;
	val_64.nat_val_64 = RTU64C(0x7FF8000000000000);
	eif_real_64_nan = val_64.real_val_64;

		/* Computation of Negative Infinity. */
	val_32.nat_val_32 = 0xFF800000;
	eif_real_32_negative_infinity = val_32.real_val_32;
	val_64.nat_val_64 = RTU64C(0xFFF0000000000000);
	eif_real_64_negative_infinity = val_64.real_val_64;

		/* Computation of Positive Infinity. */
	val_32.nat_val_32 = 0x7F800000;
	eif_real_32_positive_infinity = val_32.real_val_32;
	val_64.nat_val_64 = RTU64C(0x7FF0000000000000);
	eif_real_64_positive_infinity = val_64.real_val_64;
}

int main (int argc, char ** argv) {
  ieee_init();
  printf("Negative infinity 32 = %f\n", eif_real_32_negative_infinity);
  printf("Positive infinity 32 = %f\n", eif_real_32_positive_infinity);
  printf("Not a number 32 = %f\n", eif_real_32_nan);
  printf("Negative infinity 64 = %lf\n", eif_real_64_negative_infinity);
  printf("Positive infinity 64 = %lf\n", eif_real_64_positive_infinity);
  printf("Not a number 64 = %lf\n", eif_real_64_nan);
  return 0;
}

